/* an Intrvl is an ordered pair of real numbers */
/* each real number has an associated pointer to private data */
struct Intrvl {
        struct Intrvl *next;
        struct {float val; void *misc;} start,end;
};

/* a Set is an ordered collection of disjoint Intrvls */
typedef struct Intrvl *Set;

Set _MakeSet(); /* create an interval at the head of a set */
#define MakeSet(s,e) _MakeSet(s,e,NULL)
Set USet(); /* find the union of two Sets */
Set ISet(); /* find the intersection of two Sets */
Set DSet(); /* find the difference between two Sets */
